=== debian/changelog ===
cmake (2.8.1-4~lucid1) lucid-backports; urgency=low

  * Automated backport upload; no source changes.

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 28 May 2010 17:12:09 +0100

cmake (2.8.1-4) unstable; urgency=low

  * Further improve FinJNI.cmake. This should fix some inconsistencies on s390.
  * Add cpack_installed_size.diff to fix generation of Installed-Size field for
    deb packages. Thanks to Simone Rossetto for heads up and initial patch.

 -- Modestas Vainius <modax@debian.org>  Mon, 17 May 2010 01:24:41 +0300

cmake (2.8.1-3) unstable; urgency=medium

  * Add patches:
    - FindJNI_fix_libarch_determination.dif - rewrite _java_libarch
      determination code in FindJNI.cmake (based on OpenJDK 1.6.0_18 + icedtea
      patches). This should fix invalid _java_libarch detection on mipsel and
      armel (Closes: #544674).
    - FindGTK2_pangommconfig.diff - look for Pangomm Config include directory
      in FindGTK2.cmake (Closes: #579718). Thanks to Sune Vuorela for the
      patch.
  * Add gcc and make to cmake Suggests (Closes: #577516).
  * Rename (to kFreeBSD_Hurd_fixes.diff) and improve kFreeBSD_fixes.diff to fix
    FTBFS on GNU/Hurd as well.
  * Urgency=medium to minimize negative impact on KDE transition.

 -- Modestas Vainius <modax@debian.org>  Wed, 05 May 2010 11:49:57 +0300

cmake (2.8.1-2) unstable; urgency=low

  * Add kFreeBSD_fixes.diff patch to fix FTBFS on kfreebsd-* (failure of the
    CTestTestTimeout test).

 -- Modestas Vainius <modax@debian.org>  Thu, 18 Mar 2010 01:45:08 +0200

cmake (2.8.1-1) unstable; urgency=low

  * New upstream release.
  * Remove DMUA entry from debian/control. No longer needed.
  * Enable building in parallel (--parallel).
  * Update debian/patches:
    - drop bootstraptest_increase_timeout.diff - merged upstream;
    - hurd_platform.diff - adapt to upstream changes.
  * Forcefully set MINGW_CC_LINUX2WIN_EXECUTABLE to empty value. It breaks
    otherwise valid Simple_Mingw_Linux2Win test when ccache is enabled.
  * Update install files.
  * Update Standards-Version to 3.8.4: no changes needed.
  * Change my email address to modax@debian.org.

 -- Modestas Vainius <modax@debian.org>  Wed, 17 Mar 2010 17:51:38 +0200
